=== debian/changelog ===
milkytracker (1.02.00+dfsg-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:19:47 +0100

milkytracker (1.02.00+dfsg-2) unstable; urgency=high

  [ Utkarsh Gupta ]
  * Add patch to fix heap-based and stack-based buffer overflows.
    (Closes: #933964) (Fixes: CVE-2019-14464, CVE-2019-14496, CVE-2019-14497)

  [ Ondřej Nový ]
  * d/control: Unify Maintainer field to Debian Multimedia Maintainers.
  * Use debhelper-compat instead of debian/compat.

  [ Gürkan Myczko ]
  * Update list of tracker music applications in d/control and
    d/milkytracker.1.

  [ Olivier Humbert ]
  * Update d/control : http -> https + remove 1 useless empty line.
  * Update d/copyright : http->https + remove 1 empty line.
  * Update d/milkytracker.desktop: add a French comment.

 -- James Cowgill <jcowgill@debian.org>  Mon, 28 Oct 2019 17:28:45 +0000

milkytracker (1.02.00+dfsg-1) unstable; urgency=medium

  * New upstream version.

  * debian/patches:
    - Drop patches applied upstream.

 -- James Cowgill <jcowgill@debian.org>  Sun, 25 Feb 2018 10:15:54 +0000

milkytracker (1.01.00+dfsg-2) unstable; urgency=high

  [ Ondřej Nový ]
  * d/copyright: Use https protocol in Format field
  * d/control: Set Vcs-* to salsa.debian.org

  [ James Cowgill ]
  * debian/compat:
    - Use debhelper compat 11.
  * debian/control:
    - Set maintainer to debian-multimedia@l.d.o.
    - Set Rules-Requires-Root: no.
    - Bump standards to 4.1.3.
  * debian/patches:
    - Apply upstream patches to fix various buffer overflows.
      Thanks to Johannes Schultz (Closes: #890407)

 -- James Cowgill <jcowgill@debian.org>  Thu, 22 Feb 2018 23:47:13 +0000
