=== debian/control ===
Source: milkytracker
Section: sound
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Gürkan Myczko <gurkan@phys.ethz.ch>,
 James Cowgill <jcowgill@debian.org>
Build-Depends:
 cmake,
 debhelper-compat (= 11),
 dh-exec,
 libasound2-dev [linux-any],
 liblhasa-dev,
 libsdl2-dev,
 libjack-dev,
 librtmidi-dev [linux-any],
 libzzip-dev,
 zlib1g-dev
Rules-Requires-Root: no
Homepage: https://milkytracker.titandemo.org/
Standards-Version: 4.1.3
Vcs-Git: https://salsa.debian.org/multimedia-team/milkytracker.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/milkytracker

Package: milkytracker
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: freepats, bambootracker, cheesecutter, protracker, hivelytracker, opencubicplayer, modplug-tools, schism, goattracker
Description: music creation tool inspired by Fast Tracker 2
 This is an editor for "tracked" music, i.e. audio samples of instruments
 pitch shifted according to the note data.
 .
 It can load the following module formats: 669, AMS, AMF, DBM, CBA, DIGI,
 DSM, FAR, GMC, GDM, IMF, IT, MOD, MDL, MTM, MXM, OKT, PLM, PSM, PTM, S3M,
 STM, ULT, UNI, and X.
 .
 Export is possible into the formats: XM, MOD, and WAV.
 .
 Supported sample and instrument formats: WAV, IFF/XI, PAT
